/*
 * Copyright (c) 2015 Tricoire Sebastien 3dsman@free.fr
 *
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 * claim that you wrote the original software. If you use this software
 * in a product, an acknowledgment in the product documentation would be
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 *
 */

#pragma once

#include "stitchs/OE_birailstitch.h"
#include "actions/OE_actions.h"

class OE_actionNewBirailStitch : public OE_actions
{
	public:
		OE_actionNewBirailStitch(OE_document* doc, bool reverse1, bool reverse2, float offset1, float offset2, float len);

		virtual ~OE_actionNewBirailStitch();

		virtual void undo();
		virtual void redo();

	protected:
		OE_actions* action;
};

class OE_actionSetBirailStitchLen : public OE_actions
{
	public:
		OE_actionSetBirailStitchLen(OE_document* doc, OE_birailstitch* stitch, float len);

		virtual ~OE_actionSetBirailStitchLen();

		virtual void undo();
		virtual void redo();

	protected:
		OE_birailstitch* actionStitch;
		float oldLen;
};

class OE_actionSetBirailStitchOffset1 : public OE_actions
{
	public:
		OE_actionSetBirailStitchOffset1(OE_document* doc, OE_birailstitch* stitch, float offset);

		virtual ~OE_actionSetBirailStitchOffset1();

		virtual void undo();
		virtual void redo();

	protected:
		OE_birailstitch* actionStitch;
		float oldOffset;
};

class OE_actionSetBirailStitchOffset2 : public OE_actions
{
	public:
		OE_actionSetBirailStitchOffset2(OE_document* doc, OE_birailstitch* stitch, float offset);

		virtual ~OE_actionSetBirailStitchOffset2();

		virtual void undo();
		virtual void redo();

	protected:
		OE_birailstitch* actionStitch;
		float oldOffset;
};

class OE_actionScaleSelectedBirailStitchLen : public OE_actions
{
	public:
		OE_actionScaleSelectedBirailStitchLen(OE_document* doc, float scale);

		virtual ~OE_actionScaleSelectedBirailStitchLen();

		virtual void undo();
		virtual void redo();

		void scaleLen(float scale);

	protected:
		std::list<OE_actionSetBirailStitchLen*> actions;
};

